#define REAL double
#define FAST_TRIG

#include "trigtbl.h"
    
    char fht_version[] = "Brcwl-Hrtly-Bunemn-Ron";

void fht(f,n,stride)
REAL *f;
int n;
int stride;
{
 
 int k,k1,k2,k4,m;
 REAL x,y,u,v,c,s,g,h;
 REAL *fi,*fj,*fim,*fin,*flim,*gi,*gj;
 TRIG_VARS;

 for ( k=0 ; (1<<k)<n ; k++ );
 c     = (k&1) ? .70710678118654752440084436210484 : 1.0;
 c    /= ( 1 << (k>>1) );

 n*=stride;
 m     = (n>>1);
 k     = -1;
 k1    = 0;
 k2    = stride;
 k4    = k2+k2;
 fi    = f;
 fin   = f  + n;
 fim   = fi + m;
 gi    = fi + m;
 do
    {
     x       = gi[0];
     u       = fi[k2];
     fi[k2]  = c*(fi[0]-x);
     fi[0]   = c*(fi[0]+x);
     x       = gi[k2];
     gi[k2]  = c*(u-x);
     gi[0]   = c*(u+x);
     fi     += k4;
     gi     += k4;
    } while (fi<fim);

 while ( k4<(m>>=1) )
    {
     k++;
     k1   = stride << k;
     k2   = k1 << 1;
     k4   = k2 << 1;
     fi   = f;
     fj   = fi + k2;
     do
	{
	 fim = fi + m;
	 gi  = fi + m;
	 gj  = fj + m;
	 do
	    {
	     x       = gi[0 ];
	     u       = fj[0 ];
	     fj[0 ]  = fi[0 ] - x;
	     fi[0 ] +=          x;
	     x       = gj[0 ];
	     gj[0 ]  = u - x;
	     gi[0 ]  = u + x;
	     y       = gi[k1];
	     v       = fj[k1];
	     fj[k1]  = fi[k1] - y;
	     fi[k1] +=          y;
	     y       = gj[k1];
	     gj[k1]  = v - y;
	     gi[k1]  = v + y;
	     fj     += k4;
	     fi     += k4;
	     gj     += k4;
	     gi     += k4;
	    } while (fi<fim);
	 fi = gi;
	 fj = gj;
	} while (fi<fin);
     if (k == 0) continue;
     flim = f  + n - stride + k1;
     TRIG_INIT(k,c,s);
     do
        {
	 TRIG_NEXT(k,c,s);
	 fi  -= n - stride;
	 fj  -= n + stride;
	 do
	    {
	     fim  = fi + m;
	     gi   = fi + m;
	     gj   = fj + m;
	     do
		{
		 x        = c*gi[0 ] + s*gj[0 ];
		 y        = s*gi[0 ] - c*gj[0 ];
		 u        = fi[k2];
		 v        = fj[k2];
		 fi[k2]   = fi[0 ] - x;
		 fj[k2]   = fj[0 ] - y;
		 fi[0 ]  += x;
		 fj[0 ]  += y;
		 x        = c*gi[k2] + s*gj[k2];
		 y        = s*gi[k2] - c*gj[k2];
		 gi[k2]   = u - x;
		 gj[k2]   = v - y;
		 gi[0 ]   = u + x;
		 gj[0 ]   = v + y;
		 gj      += k4;
		 gi      += k4;
		 fj      += k4;
		 fi      += k4;
		} while (fi<fim);
	     fi = gi;
	     fj = gj;
	    } while (fi<fin);
        } while (fi<flim);
     TRIG_RESET(k,c,s);
    }
 while ( k4<n )
    {
     k++;
     k1   = stride << k;
     k2   = k1 << 1;
     k4   = k2 << 1;
     fi   = f;
     fj   = fi + k2;
     do
	{
	 x       = fj[0 ];
	 fj[0 ]  = fi[0 ] - x;
	 fi[0 ] +=          x;
	 y       = fj[k1];
	 fj[k1]  = fi[k1] - y;
	 fi[k1] +=          y;
	 fj     += k4;
	 fi     += k4;
	} while (fi<fin);
     if (k == 0) continue;
     flim = f  + n - stride + k1;
     TRIG_INIT(k,c,s);
     do
        {
	 TRIG_NEXT(k,c,s);
	 fi  -= n - stride;
	 fj  -= n + stride;
	 do
	    {
	     x       = c*fi[k2] + s*fj[k2];
	     y       = s*fi[k2] - c*fj[k2];
	     fi[k2]  = fi[0 ] - x;
	     fi[0 ] +=          x;
	     fj[k2]  = fj[0 ] - y;
	     fj[0 ] +=          y;
	     fj     += k4;
	     fi     += k4;
	    } while (fi<fin);
        } while (fi<flim);
     TRIG_RESET(k,c,s);
    }
}



cas2d(f,m,n)
double *f;
int m,n;
{
 int i,j;
 for (i=0;i<n;i++)
     fht(f+i*m,m,1);
 for (i=0;i<m;i++)
     fht(f+i  ,n,m);
}

#define F(f,i,j,m,n) (*(f+(i)+m*(j)))
#define A F(f,i,j,m,n)
#define B F(f,i,l,m,n)
#define C F(f,k,j,m,n)
#define D F(f,k,l,m,n)
fht2d(f,m,n)
double *f;
int m,n;
{
 double e;
 int i,j,k,l;
 cas2d(f,n,m);
 for (i=1;i<m/2;i++)
    {
     k=m-i;
     for (j=1;j<n/2;j++)
        {
	 l=n-j;
         e  = ((A+D)-(B+C))/2;
         A -= e;
         B += e;
         C += e;
         D -= e;
        }
    }
}

#define F(f,i,j,m,n) (*(f+(i)+m*(j)))
#define CONVOLVE(i,j,k,l) \
     a= (F(f,i,j,m,n)*F(g,i,j,m,n) - F(f,k,l,m,n) * F(g,k,l,m,n)); \
     b= (F(f,k,l,m,n)*F(g,i,j,m,n) + F(f,i,j,m,n) * F(g,k,l,m,n)); \
     F(h,i,j,m,n) = (b+a)/2; \
     F(h,k,l,m,n) = (b-a)/2; 
    
conv(f,g,h,m,n)
double *f,*g,*h;
int m,n;
{
 int i,j,k,l;
 double a,b;
 F(f,0  ,0  ,m,n) *= F(g,0  ,0  ,m,n);
 F(f,0  ,n/2,m,n) *= F(g,0  ,n/2,m,n);
 F(f,m/2,0  ,m,n) *= F(g,m/2,0  ,m,n);
 F(f,m/2,n/2,m,n) *= F(g,m/2,n/2,m,n);
 for (i=1;i<m/2;i++)
    {	
     k=(m-i);
     CONVOLVE(i,0,k,0);
     CONVOLVE(i,n/2,k,n/2);
    }
 for (j=1;j<n/2;j++)
    {
     l=(n-j);
     CONVOLVE(0,j,0,l);
     CONVOLVE(m/2,j,m/2,l);
    }
 for (i=1;i<m/2;i++)
    {
     k=(m-i);
     for (j=1;j<n/2;j++)
        {
	 l=(n-j);
	 CONVOLVE(i,j,k,l);
	 CONVOLVE(i,l,k,j);
	}
    }
}

